var APIBase = require("../../api.base");
var system = require("../../../system");
var settings = require("../../../../config/settings");
class BaseAPI extends APIBase {
    constructor() {
        super();
        this.aliyunqcSve = system.getObject("service.qcutils.aliyunqcSve");
        this.baiduqcSve = system.getObject("service.qcutils.baiduqcSve");
        
        this.baseqcSve = system.getObject("service.qcutils.baseqcSve");
    }
    /**
      * 接口跳转-POST请求
      * action_process  执行的流程
      * action_type     执行的类型
      * action_body     执行的参数
      */
    async springBoard(pobj, qobj, req) {
        if (!pobj.actionType) {
            return system.getResult(null, "actionType参数不能为空");
        }
        if (pobj.actionType == 'getPolicyNeedList' || pobj.actionType == 'submitPolicyNeedNotes') {
            if (!pobj.userInfo) {
                return system.getResult(system.noLogin, "user no login!");
            }
            if (!pobj.appInfo) {
                return system.getResult(system.noLogin, "app is null!");
            }
        }
        var result = await this.opActionProcess(pobj, pobj.actionType, req);
        return result;
    }
    async opActionProcess(pobj, action_type, req) {
        console.log("pobj",pobj)
        var opResult = null;
        switch (action_type) {
            case "receiveProgrammeNo"://接收方案编号(方案推送至阿里后,接收保存方案信息)
                opResult = await this.baseqcSve.receiveProgrammeNo(pobj);
                break;
            case "submitIcpProgramme"://icp方案提交
                opResult = await this.baseqcSve.submitIcpProgramme(pobj);
                break;
            // case "submitIcpMaterial"://icp材料提交
            //     opResult = await this.baseqcSve.submitIcpMaterial(pobj);
            //     break;
            case "acceptIcpPartnerNotification"://icp通知状态变更
                opResult = await this.baseqcSve.acceptIcpPartnerNotification(pobj);
                break;
            case "abolishIcpProgramme"://服务商icp方案关闭
                opResult = await this.baseqcSve.abolishIcpProgramme(pobj);
                break;
            case "getIcpProgrammeDetail"://获取icp方案
                opResult = await this.baseqcSve.getIcpProgrammeDetail(pobj);
                break;
            case "getNeedSolutionDetailByUser"://获取方案详情
                opResult = await this.baseqcSve.getNeedSolutionDetailByUser(pobj);
                break;
            case "receiveIcpStatusNotify"://接收渠道方案状态变更通知2.3
                opResult = await this.baseqcSve.receiveIcpStatusNotify(pobj);
                break;
            case "receiveIcpFeedback"://接收icp用户方案反馈2.2
                opResult = await this.baseqcSve.receiveIcpFeedback(pobj);
                break;
            case "getIcpProgrammeDetail"://获取方案详情（内部调用）
                opResult = await this.baseqcSve.getIcpProgrammeDetail(pobj);
                break;
            case "getProgrammeInfoByChannelNeedNo"://获取需求方案列表
                opResult = await this.baseqcSve.getProgrammeInfoByChannelNeedNo(pobj);
                break;

            case "serviceProviderSubmitMaterial"://交付商提交材料信息
                opResult = await this.baseqcSve.serviceProviderSubmitMaterial(pobj);
                break;
            case "serviceProviderNotification"://交付商通知状态变更
                opResult = await this.baseqcSve.serviceProviderNotification(pobj);
                break;
            case "closeOrderDelivery"://交付商关闭交付单
                opResult = await this.baseqcSve.closeOrderDelivery(pobj);
                break;
            case "abolishIcpProgrammeByNeed"://前端关闭ICP需求及方案
                opResult = await this.baseqcSve.abolishIcpProgrammeByNeed(pobj);
                break;
            case "receiveIcpConfirmUrl"://前端关闭ICP需求及方案
                opResult = await this.baseqcSve.receiveIcpConfirmUrl(pobj);
                break;
            //-----------文网文----------- 
            case "serviceSubmitOption"://服务商提交服务操作
                opResult = await this.baseqcSve.serviceSubmitOption(pobj);
                break;
            case "submitWangwenSolution"://提交方案
                opResult = await this.baseqcSve.submitWangwenSolution(pobj);
                break;
            case "closeNeed"://关闭需求
                opResult = await this.baseqcSve.closeNeed(pobj);
                break;
            case "recordLog"://提交沟通记录
                opResult = await this.baseqcSve.recordLog(pobj);
                break;
            //-----------食品----------- 

            case "foodServiceSubmitOption"://服务商提交服务操作
                opResult = await this.baseqcSve.foodServiceSubmitOption(pobj);
                break;
            case "submitFoodSolution"://提交方案
                opResult = await this.baseqcSve.submitFoodSolution(pobj);
                break;
            case "foodCloseNeed"://关闭需求
                opResult = await this.baseqcSve.foodCloseNeed(pobj);
                break;
            case "foodRecordLog"://提交沟通记录
                opResult = await this.baseqcSve.foodRecordLog(pobj);
                break;

            case "receiveOrderStatusNotify"://接收订单状态推送 百度icp 2.3
                opResult = await this.baiduqcSve.receiveOrderStatusNotify(pobj);
                break;
            default:
                opResult = system.getResult(null, "action_type参数错误");
                break;
        }
        return opResult;
    }
}
module.exports = BaseAPI;